#property copyright "Copyright  SK, 2007"
#property link      "http://AutoGraf.dp.ua"
//--------------------------------------------------------------------
#property indicator_separate_window // .   
#property indicator_buffers 6       //  
#property indicator_color1 Black    //   0 
#property indicator_color2 DarkOrange//  1 
#property indicator_color3 Green    //   2 
#property indicator_color4 Brown    //   3 
#property indicator_color5 Blue     //   4 
#property indicator_color6 Red      //   5 
//--------------------------------------------------------------- 2 --
extern ENUM_TIMEFRAMES TimeFrame  = PERIOD_CURRENT;
extern int             History    =5000;        // .   
extern int             Period_MA_1=21;          //   
extern int             Bars_V     =13;          // .   
extern int             Aver_Bars  =5;           // .   
//--------------------------------------------------------------- 3 --
int
   Period_MA_2,  Period_MA_3,       //     . 
   K2, K3;                          //   
double
   Line_0[],                        // .   MA
   Line_1[], Line_2[], Line_3[],    // .    
   Line_4[],                        // .  
   Line_5[],                        // .  
   Sh_1, Sh_2, Sh_3;                // .  . 
string indicatorFileName;
bool   returnBars;
//--------------------------------------------------------------- 4 --
int init()                          //   init()
  {
   SetIndexBuffer(0,Line_0);        //   
   SetIndexBuffer(1,Line_1);        //   
   SetIndexBuffer(2,Line_2);        //   
   SetIndexBuffer(3,Line_3);        //   
   SetIndexBuffer(4,Line_4);        //   
   SetIndexBuffer(5,Line_5);        //   
   SetIndexStyle (5,DRAW_LINE,STYLE_SOLID,3);//  
//--------------------------------------------------------------- 5 --
   switch(Period())                 //   ..
     {                              // ..  
      case     1: K2=5;K3=15; break;//  1
      case     5: K2=3;K3= 6; break;//  5
      case    15: K2=2;K3= 4; break;//  15
      case    30: K2=2;K3= 8; break;//  30
      case    60: K2=4;K3=24; break;//  H1
      case   240: K2=6;K3=42; break;//  H4
      case  1440: K2=7;K3=30; break;//  D1
      case 10080: K2=4;K3=12; break;//  W1
      case 43200: K2=3;K3=12; break;//  N
     }
//--------------------------------------------------------------- 6 --
   Sh_1              = Bars_V;                     //    ()
   Sh_2              = K2*Sh_1;                    //  .  . 
   Sh_3              = K3*Sh_1;                    //  .  . 
   Period_MA_2       = K2*Period_MA_1;     // .   . 
   Period_MA_3       = K3*Period_MA_1;     // .   . 
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == -99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName (timeFrameToString(TimeFrame)+" rocseparate");
//--------------------------------------------------------------- 7 --
   return(0);                          //   .  init()
  }
//--------------------------------------------------------------- 8 --
int start()                         //   start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Line_0[0] = limit+1; return(0); }
         if (TimeFrame != Period())
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
                  Line_0[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,History,Period_MA_1,Bars_V,Aver_Bars,0,y);
                  Line_1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,History,Period_MA_1,Bars_V,Aver_Bars,1,y);
                  Line_2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,History,Period_MA_1,Bars_V,Aver_Bars,2,y);
                  Line_3[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,History,Period_MA_1,Bars_V,Aver_Bars,3,y);
                  Line_4[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,History,Period_MA_1,Bars_V,Aver_Bars,4,y);
                  Line_5[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,History,Period_MA_1,Bars_V,Aver_Bars,5,y);
            }
            return(0);            
         }

//--------------------------------------------------------------- 9 --
   double
   MA_c, MA_p,                      //   . . 
   Sum;                             // .  . 
                                    //  
   int n,Counted_bars;                    //    
//-------------------------------------------------------------- 10 --
   Counted_bars=IndicatorCounted(); //    
   i=Bars-Counted_bars-1;           //   
   if (i>History-1)                 //     ..
      i=History-1;                  // ..  .
//-------------------------------------------------------------- 11 --
   while(i>=0)                      //    
     {
      //-------------------------------------------------------- 12 --
      Line_0[i]=0;                  //   
      //-------------------------------------------------------- 13 --
      MA_c=iMA(NULL,0,Period_MA_1,0,MODE_LWMA,PRICE_TYPICAL,i);
      MA_p=iMA(NULL,0,Period_MA_1,0,MODE_LWMA,PRICE_TYPICAL,i+Sh_1);
      Line_1[i]= MA_c-MA_p;         //  1  
      //-------------------------------------------------------- 14 --
      MA_c=iMA(NULL,0,Period_MA_2,0,MODE_LWMA,PRICE_TYPICAL,i);
      MA_p=iMA(NULL,0,Period_MA_2,0,MODE_LWMA,PRICE_TYPICAL,i+Sh_2);
      Line_2[i]= MA_c-MA_p;         //  2  
      //-------------------------------------------------------- 15 --
      MA_c=iMA(NULL,0,Period_MA_3,0,MODE_LWMA,PRICE_TYPICAL,i);
      MA_p=iMA(NULL,0,Period_MA_3,0,MODE_LWMA,PRICE_TYPICAL,i+Sh_3);
      Line_3[i]= MA_c-MA_p;         //  3  
      //-------------------------------------------------------- 16 --
      Line_4[i]=(Line_1[i]+Line_2[i]+Line_3[i])/3;//  
      //-------------------------------------------------------- 17 --
      if (Aver_Bars<0)              //    
         Aver_Bars=0;               // ..    
      Sum=0;                        //  
      for(n=i; n<=i+Aver_Bars; n++) //   .
         Sum=Sum + Line_4[n];       //   . .
      Line_5[i]= Sum/(Aver_Bars+1); // .   
      //-------------------------------------------------------- 18 --
      i--;                          //    
      //-------------------------------------------------------- 19 --
     }
   return(0);                          //   . - start()
  }
//-------------------------------------------------------------- 20 --

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
